# Poki Launcher

Poki Launcher is an application launcher for Linux. It tracks app usage then
ranks apps based on frecency and fuzzy search. It's written in Rust and QML. I
mostly made this for myself but if anyone else finds some use for it that'd be
great.

![Launcher Image](./media/launcher.png)

## Features

- Sorts apps by how recently and how frequently you use them producing good
results with minimal input
- Using the same fuzzy search algorithm an fzf to sort apps
- Automatically detects new apps
- i3/tiling wm compatible
- krunner(KDE) integration (septate package)

## How to Install

### Packages

- [AUR](https://aur.archlinux.org/packages/poki-launcher/)
- [OBS](https://software.opensuse.org//download.html?project=home%3Azethra&package=poki-launcher)

### From Source

- Install rust and cargo.
- Install the Qt5 base and declarative development packages for your distro.
  - Arch / Manjaro `qt5-declarative`
  - Fedora `dnf install qt5-qtbase-devel qt5-qtdeclarative-devel`
  - OpenSUSE `libqt5-qtbase-devel libqt5-qtdeclarative-devel`

```sh
git clone https://github.com/zethra/poki-launcher.git && cd poki-launcher
cargo build --release --bin poki-launcher
install -Dm755 target/release/poki-launcher /usr/bin/poki-launcher
```

## Configuration

To change any setting in the app copy the example config file installed
at `/usr/share/doc/packages/poki-launcher/examples/poki-launcher.hjson` if installed
from the package other grab it from [the repo](https://aur.archlinux.org/packages/plasma5-runners-poki-launcher/).
Copy this file to `~/.config/poki-launcher/poki-launcher.hjson`.

### Config Options

The list of config options and their defaults are in the example
config file [poki-launcher.hjson](./poki-launcher.hjson)

## Krunner Integration

Poki Launcher can also run as a krunner plugin, in addition to or instead of a
stand alone app. Once poki-launcher krunner plugin is installed in can be
enabled in Krunner settings. poki-krunner shares the same config file as
poki-launcher. Config options related to the look of poki-launcher are ignored
You will probably want to disable the Applications plugin so you don't get
duplicate results.

### Installation

#### Packages

- [AUR](https://aur.archlinux.org/packages/plasma5-runners-poki-launcher/)

### From Source

- Install rust and cargo.
- Install the dbus development libraries.

```sh
git clone https://github.com/zethra/poki-launcher.git && cd poki-launcher
cargo build --release --bin poki-krunner
install -Dm755 "target/release/poki-krunner" "/usr/bin/poki-krunner"
install -Dm644 "poki-krunner/dev.benaaron.poki-krunner.service" \
    "/usr/share/dbus-1/services/dev.benaaron.poki-krunner.service"
install -Dm644 "poki-krunner/plasma-runner-poki-launcher.desktop" \
    "/usr/share/krunner/dbusplugins/plasma-runner-poki-launcher.desktop"
```

**Q** An app isn't in the list

**A** If the app's desktop file is in a directory that's
not in the `app_paths` list in the config file they won't
show up.  If the app was installed with flatpak or snap
uncomment the lines for those in the example config file.

## Contributing

Please send any and all patches, bugs, and questions to the stargazer mailing
list [~zethra/public-inbox@lists.sr.ht](mailto:~zethra/public-inbox@lists.sr.ht)
or submit a ticket to the bug tracker if you feel so inclined
[todo.sr.ht/~zethra/poki-launcher](https://todo.sr.ht/~zethra/poki-launcher).

### Help Wanted with Packaging

If you can package stargazer please do! I currently maintain an Arch package but
if you can package for any other distro please do and let me know.

